---
title: Get widgets from an image
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Stegadography
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Get widgets from an image{% #get-widgets-from-an-image %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                        |
| ----------------- | ------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/stegadography/get-widgets |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/stegadography/get-widgets |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/stegadography/get-widgets      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/stegadography/get-widgets      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/stegadography/get-widgets  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/stegadography/get-widgets |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/stegadography/get-widgets     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/stegadography/get-widgets |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/stegadography/get-widgets |

### Overview

Extracts watermarks from a PNG image and returns the cached widget data associated with each watermark found. The image must be uploaded as a `multipart/form-data` request with the file in the `image` field. Only widgets belonging to the authenticated organization are returned.

### Request

#### Body Data (required)

PNG image to extract watermarks from.

{% tab title="Model" %}

| Field                   | Type   | Description                                     |
| ----------------------- | ------ | ----------------------------------------------- |
| image [*required*] | binary | PNG image file to scan for embedded watermarks. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "image": "screenshot.png"
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing watermarked widgets recovered from an image.

| Parent field | Field                        | Type     | Description                                                                               |
| ------------ | ---------------------------- | -------- | ----------------------------------------------------------------------------------------- |
|              | data [*required*]       | [object] | List of watermarked widget resources recovered from an image.                             |
| data         | attributes [*required*] | object   | Attributes of a watermarked widget recovered from an image.                               |
| attributes   | locationx [*required*]  | int64    | Horizontal pixel coordinate where the watermark was found in the image.                   |
| attributes   | locationy [*required*]  | int64    | Vertical pixel coordinate where the watermark was found in the image.                     |
| attributes   | rawData [*required*]    | string   | JSON-encoded string representing the widget state.                                        |
| attributes   | watermark [*required*]  | string   | Hex-encoded watermark string identifying the widget.                                      |
| data         | id [*required*]         | string   | Composite identifier formed from the organization ID and watermark, separated by a colon. |
| data         | type [*required*]       | enum     | Stegadography widget resource type. Allowed enum values: `widget`                         |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "locationx": 100,
        "locationy": 200,
        "rawData": "{\"widgetType\":\"timeseries\",\"requests\":[]}",
        "watermark": "0123456789abcdef"
      },
      "id": "abc123:0123456789abcdef",
      "type": "widget"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="415" %}
Unsupported Media Type
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/stegadography/get-widgets" \
-H "Accept: application/json" \
-H "Content-Type: multipart/form-data" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-F image=@string 
                
##### 

```python
"""
Get widgets from an image returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.stegadography_api import StegadographyApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = StegadographyApi(api_client)
    response = api_instance.get_stegadography_widgets(
        image=open("fixtures/stegadography/image.png", "rb"),
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Get widgets from an image returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::StegadographyAPI.new
p api_instance.get_stegadography_widgets(File.open("fixtures/stegadography/image.png", "r"))
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Get widgets from an image returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"io"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStegadographyApi(apiClient)
	resp, r, err := api.GetStegadographyWidgets(ctx, func() io.Reader { fp, _ := os.Open("fixtures/stegadography/image.png"); return fp }())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StegadographyApi.GetStegadographyWidgets`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `StegadographyApi.GetStegadographyWidgets`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Get widgets from an image returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StegadographyApi;
import com.datadog.api.client.v2.model.StegadographyGetWidgetsResponse;
import java.io.File;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    StegadographyApi apiInstance = new StegadographyApi(defaultClient);

    try {
      StegadographyGetWidgetsResponse result =
          apiInstance.getStegadographyWidgets(new File("fixtures/stegadography/image.png"));
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling StegadographyApi#getStegadographyWidgets");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Get widgets from an image returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_stegadography::StegadographyAPI;
use std::fs;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = StegadographyAPI::with_config(configuration);
    let resp = api
        .get_stegadography_widgets(fs::read("fixtures/stegadography/image.png").unwrap())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Get widgets from an image returns "OK" response
 */

import * as fs from "fs";
import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.StegadographyApi(configuration);

const params: v2.StegadographyApiGetStegadographyWidgetsRequest = {
  image: {
    data: Buffer.from(
      fs.readFileSync("fixtures/stegadography/image.png", "utf8")
    ),
    name: "fixtures/stegadography/image.png",
  },
};

apiInstance
  .getStegadographyWidgets(params)
  .then((data: v2.StegadographyGetWidgetsResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
